Bullet Collision Detection & Physics Library: btCollisionShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Protected Attributes | List of all members
btCollisionShape Class Referenceabstract

The btCollisionShape class provides an interface for collision shapes that can be shared among btCollisionObjects. More...

`#include <btCollisionShape.h>`

Inheritance diagram for btCollisionShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const =0
| getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t. More...
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximus radius needed for Conservative Advancement to handle time-of-impact with rotations. More...
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative More...
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check) More...
virtual void | setLocalScaling (const btVector3 &scaling)=0
virtual const btVector3 & | getLocalScaling () const =0
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const =0
virtual const char * | getName () const =0
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example More...
virtual void | setMargin (btScalar margin)=0
virtual btScalar | getMargin () const =0
void | setUserPointer (void *userPtr)
| optional user data pointer More...
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
virtual void | serializeSingleShape (btSerializer *serializer) const

## Protected Attributes
int | m_shapeType
void * | m_userPointer
int | m_userIndex

## Detailed Description

The btCollisionShape class provides an interface for collision shapes that can be shared among btCollisionObjects.

Definition at line 27 of file btCollisionShape.h.

## Constructor & Destructor Documentation

## § btCollisionShape()

btCollisionShape::btCollisionShape | ( |  | ) |
| inline

Definition at line 38 of file btCollisionShape.h.

## § ~btCollisionShape()

virtual btCollisionShape::~btCollisionShape | ( |  | ) |
| inlinevirtual

Definition at line 42 of file btCollisionShape.h.

## Member Function Documentation

## § BT_DECLARE_ALIGNED_ALLOCATOR()

btCollisionShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## § calculateLocalInertia()

virtual void btCollisionShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia
| ) |  | const
| pure virtual

Implemented in btGImpactMeshShape, btGImpactMeshShapePart, btGImpactCompoundShape, btHeightfieldTerrainShape, btSoftClusterCollisionShape, btBox2dShape, btCompoundShape, btTriangleShape, btBoxShape, btSoftBodyCollisionShape, btConeShape, btPolyhedralConvexShape, btEmptyShape, btTriangleMeshShape, btCylinderShape, btScaledBvhTriangleMeshShape, btStaticPlaneShape, btUniformScalingShape, btCapsuleShape, btConvex2dShape, btMinkowskiSumShape, btSphereShape, and btMultiSphereShape.

## § calculateSerializeBufferSize()

int btCollisionShape::calculateSerializeBufferSize | ( |  | ) | const
| inlinevirtual

Reimplemented in btGImpactMeshShape, btCompoundShape, btConvexInternalShape, btCylinderShape, btCapsuleShape, btBvhTriangleMeshShape, btConeShape, btConvexHullShape, btMultiSphereShape, btStaticPlaneShape, and btScaledBvhTriangleMeshShape.

Definition at line 162 of file btCollisionShape.h.

## § calculateTemporalAabb()

void btCollisionShape::calculateTemporalAabb | ( | const btTransform & | curTrans,
|  | const btVector3 & | linvel,
|  | const btVector3 & | angvel,
|  | btScalar | timeStep,
|  | btVector3 & | temporalAabbMin,
|  | btVector3 & | temporalAabbMax
| ) |  | const

calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative

Definition at line 60 of file btCollisionShape.cpp.

## § getAabb()

virtual void btCollisionShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax
| ) |  | const
| pure virtual

getAabb returns the axis aligned bounding box in the coordinate frame of the given transform t.

Implemented in btConvexInternalAabbCachingShape, btHeightfieldTerrainShape, btTriangleShapeEx, btSoftClusterCollisionShape, btBox2dShape, btGImpactShapeInterface, btCompoundShape, btBoxShape, btPolyhedralConvexAabbCachingShape, btConvexInternalShape, btUniformScalingShape, btSoftBodyCollisionShape, btConvex2dShape, btConvexShape, btTriangleShape, btCapsuleShape, btCylinderShape, btTriangleMeshShape, btBU_Simplex1to4, btSphereShape, btEmptyShape, btScaledBvhTriangleMeshShape, and btStaticPlaneShape.

## § getAngularMotionDisc()

btScalar btCollisionShape::getAngularMotionDisc | ( |  | ) | const
| virtual

getAngularMotionDisc returns the maximus radius needed for Conservative Advancement to handle time-of-impact with rotations.

Definition at line 50 of file btCollisionShape.cpp.

## § getAnisotropicRollingFrictionDirection()

virtual btVector3 btCollisionShape::getAnisotropicRollingFrictionDirection | ( |  | ) | const
| inlinevirtual

the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example

Reimplemented in btConeShapeZ, btConeShapeX, btCapsuleShape, btCylinderShape, and btConeShape.

Definition at line 116 of file btCollisionShape.h.

## § getBoundingSphere()

void btCollisionShape::getBoundingSphere | ( | btVector3 & | center,
|  | btScalar & | radius
| ) |  | const
| virtual

Definition at line 32 of file btCollisionShape.cpp.

## § getContactBreakingThreshold()

btScalar btCollisionShape::getContactBreakingThreshold | ( | btScalar | defaultContactThresholdFactor | ) | const
| virtual

Definition at line 45 of file btCollisionShape.cpp.

## § getLocalScaling()

virtual const btVector3& btCollisionShape::getLocalScaling | ( |  | ) | const
| pure virtual

Implemented in btGImpactMeshShapePart, btGImpactShapeInterface, btHeightfieldTerrainShape, btCompoundShape, btConvexInternalShape, btSoftBodyCollisionShape, btUniformScalingShape, btConvex2dShape, btConvexShape, btConvexTriangleMeshShape, btTriangleMeshShape, btEmptyShape, btStaticPlaneShape, and btScaledBvhTriangleMeshShape.

## § getMargin()

virtual btScalar btCollisionShape::getMargin | ( |  | ) | const
| pure virtual

Implemented in btGImpactMeshShapePart, btSoftClusterCollisionShape, btCompoundShape, btConvexInternalShape, btUniformScalingShape, btConvex2dShape, btConvexShape, btSphereShape, btMinkowskiSumShape, and btConcaveShape.

## § getName()

virtual const char* btCollisionShape::getName | ( |  | ) | const
| pure virtual

Implemented in btGImpactMeshShape, btGImpactMeshShapePart, btGImpactCompoundShape, btBox2dShape, btBoxShape, btCylinderShapeZ, btHeightfieldTerrainShape, btTriangleShape, btSoftClusterCollisionShape, btCapsuleShapeZ, btCylinderShapeX, btConeShapeZ, btCompoundShape, btCapsuleShapeX, btCylinderShape, btConeShapeX, btMultimaterialTriangleMeshShape, btSoftBodyCollisionShape, btConvexPointCloudShape, btConeShape, btTriangleMeshShape, btConvexHullShape, btBvhTriangleMeshShape, btCapsuleShape, btBU_Simplex1to4, btMultiSphereShape, btStaticPlaneShape, btUniformScalingShape, btScaledBvhTriangleMeshShape, btEmptyShape, btMinkowskiSumShape, btSphereShape, btConvex2dShape, and btConvexTriangleMeshShape.

## § getShapeType()

int btCollisionShape::getShapeType | ( |  | ) | const
| inline

Definition at line 112 of file btCollisionShape.h.

## § getUserIndex()

int btCollisionShape::getUserIndex | ( |  | ) | const
| inline

Definition at line 139 of file btCollisionShape.h.

## § getUserPointer()

void* btCollisionShape::getUserPointer | ( |  | ) | const
| inline

Definition at line 130 of file btCollisionShape.h.

## § isCompound()

bool btCollisionShape::isCompound | ( |  | ) | const
| inline

Definition at line 85 of file btCollisionShape.h.

## § isConcave()

bool btCollisionShape::isConcave | ( |  | ) | const
| inline

Definition at line 81 of file btCollisionShape.h.

## § isConvex()

bool btCollisionShape::isConvex | ( |  | ) | const
| inline

Definition at line 73 of file btCollisionShape.h.

## § isConvex2d()

bool btCollisionShape::isConvex2d | ( |  | ) | const
| inline

Definition at line 68 of file btCollisionShape.h.

## § isInfinite()

bool btCollisionShape::isInfinite | ( |  | ) | const
| inline

isInfinite is used to catch simulation error (aabb check)

Definition at line 96 of file btCollisionShape.h.

## § isNonMoving()

bool btCollisionShape::isNonMoving | ( |  | ) | const
| inline

Definition at line 77 of file btCollisionShape.h.

## § isPolyhedral()

bool btCollisionShape::isPolyhedral | ( |  | ) | const
| inline

Definition at line 63 of file btCollisionShape.h.

## § isSoftBody()

bool btCollisionShape::isSoftBody | ( |  | ) | const
| inline

Definition at line 90 of file btCollisionShape.h.

## § serialize()

const char * btCollisionShape::serialize | ( | void * | dataBuffer,
|  | btSerializer * | serializer
| ) |  | const
| virtual

fills the dataBuffer and returns the struct name (and 0 on failure)

Reimplemented in btGImpactMeshShape, btCompoundShape, btConvexInternalShape, btCylinderShape, btCapsuleShape, btBvhTriangleMeshShape, btConeShape, btConvexHullShape, btMultiSphereShape, btStaticPlaneShape, and btScaledBvhTriangleMeshShape.

Definition at line 99 of file btCollisionShape.cpp.

## § serializeSingleShape()

void btCollisionShape::serializeSingleShape | ( | btSerializer * | serializer | ) | const
| virtual

Definition at line 113 of file btCollisionShape.cpp.

## § setLocalScaling()

virtual void btCollisionShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| pure virtual

Implemented in btGImpactMeshShape, btGImpactMeshShapePart, btConvexInternalAabbCachingShape, btGImpactShapeInterface, btHeightfieldTerrainShape, btBox2dShape, btCompoundShape, btCylinderShape, btPolyhedralConvexAabbCachingShape, btConeShape, btConvexPointCloudShape, btBoxShape, btConvexInternalShape, btCapsuleShape, btSoftBodyCollisionShape, btConvexHullShape, btBvhTriangleMeshShape, btUniformScalingShape, btConvex2dShape, btConvexShape, btConvexTriangleMeshShape, btTriangleMeshShape, btStaticPlaneShape, btEmptyShape, and btScaledBvhTriangleMeshShape.

## § setMargin()

virtual void btCollisionShape::setMargin | ( | btScalar | margin | ) |
| pure virtual

Implemented in btGImpactMeshShape, btGImpactMeshShapePart, btGImpactShapeInterface, btSoftClusterCollisionShape, btCompoundShape, btBox2dShape, btConvexInternalShape, btBoxShape, btUniformScalingShape, btConvex2dShape, btConvexShape, btCylinderShape, btSphereShape, btConcaveShape, and btCapsuleShape.

## § setUserIndex()

void btCollisionShape::setUserIndex | ( | int | index | ) |
| inline

Definition at line 134 of file btCollisionShape.h.

## § setUserPointer()

void btCollisionShape::setUserPointer | ( | void * | userPtr | ) |
| inline

optional user data pointer

Definition at line 125 of file btCollisionShape.h.

## Member Data Documentation

## § m_shapeType

int btCollisionShape::m_shapeType
| protected

Definition at line 30 of file btCollisionShape.h.

## § m_userIndex

int btCollisionShape::m_userIndex
| protected

Definition at line 32 of file btCollisionShape.h.

## § m_userPointer

void* btCollisionShape::m_userPointer
| protected

Definition at line 31 of file btCollisionShape.h.

The documentation for this class was generated from the following files:

- btCollisionShape.h
- btCollisionShape.cpp